Subject: RE: bug#25818: 25.2; frame moved off display does not return (OS X)

From: Drew Adams <[email-masked]>
Date: Wed, 1 Mar 2017 08:10:35 -0800 (PST)

> I can see the point of your argument. After all, this is how Emacs
> work today, and most people have been fine with it.
> 
> However, I don't feel 100% comfortable with the current situation.
> 
> The main issue is people with laptops connected to an extern monitor.
> When the external monitor is disconnected, Emacs might land off screen.
> I would imagine that most people would prefer that Emacs would be
> moved and resized to fit in the screen of the laptop (as I imagine,
> most macOS application behave).

> Secondly, I miss an easy accessible method to move off-screen frames
> into the visible parts of the display. On macOS, the menu is always
> accessible even if the window isn't, so the obvious place would be
> a menu item like "Collect Frame" (I noticed that "C-x 5 c" is unbound)
> -- it could be placed after "Delete Frame" in the "File" menu.

I think I agree with everything you wrote.

Users & Emacs-Lisp code should be able to position a frame partially
or fully off-screen.

But users should have simple ways to bring a given frame or all
frames that are completely off screen on screen.

And I agree with Martin's observation that such things should be
available from Emacs, but when a window mgr does something we don't
want wrt positioning users (and Emacs code) should be able to try
to compensate in some way (change the position to something that is
acceptable by the window mgr).  And our doc should make clear to
users that Emacs doesn't get the last word, so that some behavior
they see may be imposed by the window mgr, i.e., beyond Emacs's
control.